openni_wrapper::Image Class Referenceabstract
Module io

Image class containing just a reference to image meta data. More...

`#include <pcl/io/openni_camera/openni_image.h>`

Inheritance diagram for openni_wrapper::Image:

## Public Types

enum | Encoding { BAYER_GRBG, YUV422, RGB }
typedef boost::shared_ptr< Image > | Ptr
typedef boost::shared_ptr< const Image > | ConstPtr

## Public Member Functions

| Image (boost::shared_ptr< xn::ImageMetaData > image_meta_data) throw ()
| Constructor. More...
virtual | ~Image () throw ()
| virtual Destructor that never throws an exception. More...
virtual bool | isResizingSupported (unsigned input_width, unsigned input_height, unsigned output_width, unsigned output_height) const =0
virtual void | fillRGB (unsigned width, unsigned height, unsigned char *rgb_buffer, unsigned rgb_line_step=0) const =0
| fills a user given buffer with the RGB values, with an optional nearest-neighbor down sampling and an optional subregion More...
virtual Encoding | getEncoding () const =0
| returns the encoding of the native data. More...
void | fillRaw (unsigned char *rgb_buffer) const throw ()
| fills a user given buffer with the raw values. More...
virtual void | fillGrayscale (unsigned width, unsigned height, unsigned char *gray_buffer, unsigned gray_line_step=0) const =0
| fills a user given buffer with the gray values, with an optional nearest-neighbor down sampling and an optional subregion More...
unsigned | getWidth () const throw ()
unsigned | getHeight () const throw ()
unsigned | getFrameID () const throw ()
unsigned long | getTimeStamp () const throw ()
const xn::ImageMetaData & | getMetaData () const throw ()

## Protected Attributes

boost::shared_ptr< xn::ImageMetaData > | image_md_

## Detailed Description

Image class containing just a reference to image meta data.

Thus this class just provides an interface to fill a RGB or Grayscale image buffer.

Author
  Suat Gedikli

Date
  02.january 2011

Parameters

  [in] | image_meta_data |

Definition at line 58 of file openni_image.h.

## Member Typedef Documentation

typedef boost::shared_ptr<const Image> openni_wrapper::Image::ConstPtr

Definition at line 62 of file openni_image.h.

typedef boost::shared_ptr<Image> openni_wrapper::Image::Ptr

Definition at line 61 of file openni_image.h.

## Member Enumeration Documentation

enum openni_wrapper::Image::Encoding

Enumerator
BAYER_GRBG |
YUV422 |
RGB |

Definition at line 64 of file openni_image.h.

## Constructor & Destructor Documentation

openni_wrapper::Image::Image | ( | boost::shared_ptr< xn::ImageMetaData > | image_meta_data | ) |
throw | ( |
| ) |  |

inline

Constructor.

Author
  Suat Gedikli

Parameters

  [in] | image_meta_data | the actual image data from the OpenNI driver

Definition at line 171 of file openni_image.h.

openni_wrapper::Image::~Image | ( |  | ) |
throw | ( |
| ) |  |

inline virtual

virtual Destructor that never throws an exception.

Author
  Suat Gedikli

Definition at line 176 of file openni_image.h.

## Member Function Documentation

virtual void openni_wrapper::Image::fillGrayscale | ( | unsigned | width,
|  | unsigned | height,
|  | unsigned char * | gray_buffer,
|  | unsigned | gray_line_step = `0`
| ) |  | const

pure virtual

fills a user given buffer with the gray values, with an optional nearest-neighbor down sampling and an optional subregion

Author
  Suat Gedikli

Parameters

  [in] | width | desired width of output image.
  [in] | height | desired height of output image.
  [in,out] | gray_buffer | the output gray buffer.
  [in] | gray_line_step | optional line step in bytes to allow the output in a rectangular subregion of the output buffer.

Implemented in openni_wrapper::ImageBayerGRBG, openni_wrapper::ImageRGB24, and openni_wrapper::ImageYUV422.

void openni_wrapper::Image::fillRaw | ( | unsigned char * | rgb_buffer | ) | const
throw | ( |
| ) |  |

inline

fills a user given buffer with the raw values.

Author
  Suat Gedikli

Parameters

  [in,out] | rgb_buffer |

Definition at line 119 of file openni_image.h.

virtual void openni_wrapper::Image::fillRGB | ( | unsigned | width,
|  | unsigned | height,
|  | unsigned char * | rgb_buffer,
|  | unsigned | rgb_line_step = `0`
| ) |  | const

pure virtual

fills a user given buffer with the RGB values, with an optional nearest-neighbor down sampling and an optional subregion

Author
  Suat Gedikli

Parameters

  [in] | width | desired width of output image.
  [in] | height | desired height of output image.
  [in,out] | rgb_buffer | the output RGB buffer.
  [in] | rgb_line_step | optional line step in bytes to allow the output in a rectangular subregion of the output buffer.

Implemented in openni_wrapper::ImageBayerGRBG, openni_wrapper::ImageRGB24, and openni_wrapper::ImageYUV422.

virtual Encoding openni_wrapper::Image::getEncoding | ( |  | ) | const

pure virtual

returns the encoding of the native data.

Author
  Suat Gedikli

Returns
  encoding

Implemented in openni_wrapper::ImageBayerGRBG, openni_wrapper::ImageRGB24, and openni_wrapper::ImageYUV422.

unsigned openni_wrapper::Image::getFrameID | ( |  | ) | const
throw | ( |
| ) |  |

inline

Author
  Suat Gedikli

Returns
  frame id of the image.

Note
  frame ids are ascending, but not necessarily synch'ed with other streams

Definition at line 191 of file openni_image.h.

unsigned openni_wrapper::Image::getHeight | ( |  | ) | const
throw | ( |
| ) |  |

inline

Author
  Suat Gedikli

Returns
  height of the image

Definition at line 185 of file openni_image.h.

const xn::ImageMetaData & openni_wrapper::Image::getMetaData | ( |  | ) | const
throw | ( |
| ) |  |

inline

Author
  Suat Gedikli

Returns
  the actual data in native OpenNI format.

Definition at line 203 of file openni_image.h.

unsigned long openni_wrapper::Image::getTimeStamp | ( |  | ) | const
throw | ( |
| ) |  |

inline

Author
  Suat Gedikli

Returns
  the time stamp of the image

Note
  the time value is not synche'ed with the system time

Definition at line 197 of file openni_image.h.

unsigned openni_wrapper::Image::getWidth | ( |  | ) | const
throw | ( |
| ) |  |

inline

Author
  Suat Gedikli

Returns
  width of the image

Definition at line 179 of file openni_image.h.

virtual bool openni_wrapper::Image::isResizingSupported | ( | unsigned | input_width,
|  | unsigned | input_height,
|  | unsigned | output_width,
|  | unsigned | output_height
| ) |  | const

pure virtual

Author
  Suat Gedikli

Parameters

  [in] | input_width | width of input image
  [in] | input_height | height of input image
  [in] | output_width | width of desired output image
  [in] | output_height | height of desired output image

Returns
  wheter the resizing is supported or not.

Implemented in openni_wrapper::ImageBayerGRBG, openni_wrapper::ImageRGB24, and openni_wrapper::ImageYUV422.

## Member Data Documentation

boost::shared_ptr<xn::ImageMetaData> openni_wrapper::Image::image_md_

protected

Definition at line 168 of file openni_image.h.

The documentation for this class was generated from the following file:

- /build/pcl-6_P28C/pcl-1.7.2/io/include/pcl/io/openni_camera/openni_image.h